| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ClientInterfaceRequestsInterface Class Reference
Client-side proxies » Client proxies

`#include <TelepathyQt/Client>`

Inheritance diagram for Tp::Client::ClientInterfaceRequestsInterface:
[legend]

## Public Slots

QDBusPendingReply | AddRequest (const QDBusObjectPath &request, const QVariantMap &properties, int timeout=-1)
QDBusPendingReply | RemoveRequest (const QDBusObjectPath &request, const QString &error, const QString &message, int timeout=-1)

## Public Member Functions

| ClientInterfaceRequestsInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ClientInterfaceRequestsInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ClientInterfaceRequestsInterface (Tp::DBusProxy *proxy)
| ClientInterfaceRequestsInterface (const Tp::Client::ClientInterface &mainInterface)
| ClientInterfaceRequestsInterface (const Tp::Client::ClientInterface &mainInterface, QObject *parent)
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const
Public Member Functions inherited from QDBusAbstractInterface
virtual | ~QDBusAbstractInterface ()
bool | isValid () const
QDBusConnection | connection () const
QString | service () const
QString | path () const
QString | interface () const
QDBusError | lastError () const
void | setTimeout (int timeout)
int | timeout () const
QDBusMessage | call (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | call (QDBus::CallMode mode, const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | callWithArgumentList (QDBus::CallMode mode, const QString &method, const QList< QVariant > &args)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *returnMethod, const char *errorMethod)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *slot)
QDBusPendingCall | asyncCall (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusPendingCall | asyncCallWithArgumentList (const QString &method, const QList< QVariant > &args)
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
virtual const QMetaObject * | metaObject () const
QString | objectName () const
void | setObjectName (const QString &name)
bool | isWidgetType () const
bool | signalsBlocked () const
bool | blockSignals (bool block)
QThread * | thread () const
void | moveToThread (QThread *targetThread)
int | startTimer (int interval)
void | killTimer (int id)
T | findChild (const QString &name) const
QList< T > | findChildren (const QString &name) const
QList< T > | findChildren (const QRegExp &regExp) const
QObject * | child (const char *objName, const char *inheritsClass, bool recursiveSearch) const
const QObjectList & | children () const
void | setParent (QObject *parent)
void | installEventFilter (QObject *filterObj)
void | removeEventFilter (QObject *obj)
bool | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const
bool | disconnect (const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *receiver, const char *method)
void | dumpObjectTree ()
void | dumpObjectInfo ()
bool | setProperty (const char *name, const QVariant &value)
QVariant | property (const char *name) const
QList< QByteArray > | dynamicPropertyNames () const
void | destroyed (QObject *obj)
QObject * | parent () const
bool | inherits (const char *className) const
void | deleteLater ()
| QObject (QObject *parent, const char *name)
void | insertChild (QObject *object)
void | removeChild (QObject *object)
bool | isA (const char *className) const
const char * | className () const
const char * | name () const
const char * | name (const char *defaultName) const
void | setName (const char *name)

## Static Public Member Functions

static QLatin1String | staticInterfaceName ()
Static Public Member Functions inherited from QObject
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
bool | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)

## Protected Member Functions

virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const
Protected Member Functions inherited from QObject
QObject * | sender () const
int | senderSignalIndex () const
int | receivers (const char *signal) const
virtual void | timerEvent (QTimerEvent *event)
virtual void | childEvent (QChildEvent *event)
virtual void | customEvent (QEvent *event)
virtual void | connectNotify (const char *signal)
virtual void | disconnectNotify (const char *signal)
bool | checkConnectArgs (const char *signal, const QObject *object, const char *method)

## Additional Inherited Members

Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)
Protected Slots inherited from Tp::AbstractInterface
Static Protected Member Functions inherited from QObject
QByteArray | normalizeSignalSlot (const char *signalSlot)
Properties inherited from QObject
| objectName

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Client.Interface.Requests".

## Constructor & Destructor Documentation

## § ClientInterfaceRequestsInterface() [1/5]

Tp::Client::ClientInterfaceRequestsInterface::ClientInterfaceRequestsInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ClientInterfaceRequestsInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ClientInterfaceRequestsInterface() [2/5]

Tp::Client::ClientInterfaceRequestsInterface::ClientInterfaceRequestsInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ClientInterfaceRequestsInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ClientInterfaceRequestsInterface() [3/5]

Tp::Client::ClientInterfaceRequestsInterface::ClientInterfaceRequestsInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ClientInterfaceRequestsInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## § ClientInterfaceRequestsInterface() [4/5]

Tp::Client::ClientInterfaceRequestsInterface::ClientInterfaceRequestsInterface | ( | const Tp::Client::ClientInterface & | mainInterface | ) |

explicit

Creates a ClientInterfaceRequestsInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters

  mainInterface | The proxy to use.

## § ClientInterfaceRequestsInterface() [5/5]

Tp::Client::ClientInterfaceRequestsInterface::ClientInterfaceRequestsInterface | ( | const Tp::Client::ClientInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ClientInterfaceRequestsInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

## § staticInterfaceName()

static QLatin1String Tp::Client::ClientInterfaceRequestsInterface::staticInterfaceName | ( |  | ) |

inline static

Returns the name of the interface "org.freedesktop.Telepathy.Client.Interface.Requests", which this class represents.

Returns
  The D-Bus interface name.

## § requestAllProperties()

Tp::PendingVariantMap* Tp::Client::ClientInterfaceRequestsInterface::requestAllProperties | ( |  | ) | const

inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

## § AddRequest

QDBusPendingReply Tp::Client::ClientInterfaceRequestsInterface::AddRequest | ( | const QDBusObjectPath & | request,
|  | const QVariantMap & | properties,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `AddRequest` on the remote object.

Called by the ChannelDispatcher to indicate that channels have been requested, and that if the request is successful, they will probably be handled by this Handler. The ChannelDispatcher SHOULD only call this method on one handler per request.

This allows the UI to start preparing to handle the channels in advance (e.g. render a window with an "in progress" message), improving perceived responsiveness.

The use of "probably" is because you can't necessarily tell from a channel request which handler will handle particular channels. A reasonable heuristic would be to match the request against the ClientHandlerInterface::HandlerChannelFilter , and respect the preferred handler (if any).

If the request succeeds and is given to the expected Handler, the Requests_Satisfied parameter to ClientHandlerInterface::HandleChannels() can be used to match the channel to a previous AddRequest call.

This lets the UI direct the channels to the window that it already opened.

If the request fails, the expected handler is notified by the channel dispatcher calling its RemoveRequest() method.

This lets the UI close the window or display the error.

The channel dispatcher SHOULD remember which handler was notified, and if the channel request succeeds, it SHOULD dispatch the channels to the expected handler, unless the channels do not match that handler's ClientHandlerInterface::HandlerChannelFilter . If the channels are not dispatched to the expected handler, the handler that was expected is notified by the channel dispatcher calling its RemoveRequest() method with the NotYours error.

Expected handling is for the UI to close the window it previously opened.

Handlers SHOULD NOT return an error from this method; errors returned from this method SHOULD NOT alter the channel dispatcher's behaviour.

Calls to this method are merely a notification.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  request

      The ChannelRequest object, which MUST have been returned by
      CreateChannel or EnsureChannel before this method is called. See
      those methods for the rationale of this ordering.

  properties

      Some of the properties of the ChannelRequest. To avoid race
      conditions, this dictionary MUST NOT include properties whose
      values could subsequently change. It SHOULD include as many
      properties as possible, given that constraint. In particular, the
      properties Requests, UserActionTime and Account MUST be included,
      and Hints MUST be included if implemented.

  timeout | The timeout in milliseconds.

## § RemoveRequest

QDBusPendingReply Tp::Client::ClientInterfaceRequestsInterface::RemoveRequest | ( | const QDBusObjectPath & | request,
|  | const QString & | error,
|  | const QString & | message,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `RemoveRequest` on the remote object.

Called by the ChannelDispatcher to indicate that a request previously passed to AddRequest() has failed and should be disregarded.

Handlers SHOULD NOT return an error from this method; errors returned from this method SHOULD NOT alter the channel dispatcher's behaviour.

Calls to this method are merely a notification.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  request

      The request that failed.

  error | The name of the D-Bus error with which the request failed. If this is `org.freedesktop.Telepathy.Error.NotYours`, this indicates that the request succeeded, but all the resulting channels were given to some other handler.

  message

      Any message supplied with the D-Bus error.

  timeout | The timeout in milliseconds.

## § invalidate()

void Tp::Client::ClientInterfaceRequestsInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |

protected virtual

Reimplemented from Tp::AbstractInterface.